# Neo einrichten

Nachdem du dich ein wenig mit Neo beschäftigt hast und dir über alle Vor- und Nachteile von Neo im Klaren bist, bist du nun bereit, auf Neo umzusteigen und es dafür zunächst einzurichten. Auch wenn du natürlich die Möglichkeit hast, Neo „nur mal kurz“ auszuprobieren, empfehlen wir dir eher, dich ganz bewusst für oder gegen einen Umstieg auf Neo zu entscheiden und dann auch dabei zu bleiben.

Keine Panik: Das Einrichten ist einfacher, als die Länge dieser Seite befürchten lässt. Diese Seite dient als Überblick und Einstieg in die einzelnen Anleitungen. Da Neo auf verschiedenen Systemen eingerichtet werden kann, gibt es für jedes System eine eigene Anleitung.


## Windows

Das Neo-Tastaturlayout ist standardmäßig nicht in Windows enthalten und muss manuell nachinstalliert werden. Dafür stehen drei unterschiedliche Wege zur Verfügung, die jeweils ihre Vor- und Nachteile haben. Welcher der richtige ist, hängt von den eigenen Bedürfnissen ab.

Unter Windows hat nicht jeder vollen Zugriff (Administrator-Rechte) auf den vor ihm stehenden Computer, beispielsweise in der Firma oder Universität. Zwei der drei Varianten laufen als normales Programm im Hintergrund mit Benutzerrechten, eine Variante installiert ein systemweites Tastaturlayout.

Bei Problemen hilft ein Blick in die unter [FAQ](/FAQ) stehende Liste der [bekannten Probleme unter Windows](/FAQ#windows). Wenn du direkte Hilfe brauchst, wende dich [an uns!](/Kontakt/community)

- **[NeoVars (Benutzerskript)](neovars.md)**  
  Dieses Programm ist in der [AutoHotkey](https://www.autohotkey.com)-Skriptsprache geschrieben und eignet sich vor allen Dingen zum Ausprobieren bzw. für die kurzfristige Nutzung an fremden Rechnern, aber auch zur dauerhaften Verwendung ohne Administratorrechte. Zum Starten dieses Treibers reicht ein einfacher Doppelklick auf eine ».exe«-Datei aus.
- **[kbdneo (natives Layout)](kbdneo.md)**  
  Mit diesem Treiber kann man Neo permanent auf seinem Rechner als natives Tastaturlayout installieren, verfügbar für alle Benutzer. Dadurch wird eine bessere Systemintegration erreicht, allerdings benötigt man auch Administratorrechte. 
- **[neo2-llkh (Benutzerprogramm)](https://github.com/MaxGyver83/neo2-llkh)**  
  Diese Variante benötigt wie NeoVars weder eine Installation noch Administratorrechte. Man lädt nur eine ».exe«-Datei und eine Textdatei für die Einstellungen herunter. [neo2-llkh](https://github.com/MaxGyver83/neo2-llkh) wird offiziell nicht vom Neo-Team gepflegt, aber bei Problemen helfen wir gerne weiter.

??? info "Unterschiede und Vergleich der Programme"
    | | NeoVars | kbdneo | neo2-llkh |
    | --- | :---: | :---: | :---: |
    |läuft ohne Adminrechte | ja | nein | ja |
    |Kompatibilität zu anderen Programmen | sehr gut | meistens | sehr gut |
    |Stabilität | „verhakt“ sich mit Fehlermeldung, muss dann neu gestartet werden | natives Layout | gut(?) |
    |beliebige Neo-basierte Layouts möglich | ja | nein | ja |
    |Unterstützung aller Zeichen | ja | ja | nein |
    |Vertauschen<br>von Mod-Tasten | nein | nein | ja |
    |temporäres Deaktiveren | ja | ja | nein |
    |Bildschirmtastatur | ja (dynamisch) | ja | nein |
    |Einhand-Modus | ja | nein | nein |
 

## [Linux](Linux.md)

Die Einrichtung von Neo oder auf Neo basierten Layouts unter Linux wird unter [Neo einrichten](Linux.md) im Einzelnen beschrieben. Bei allen modernen Systemen sind die Layouts bereit vorinstalliert. Zum Aktivieren reicht es aus, diese in den Tastatureinstellungen auszuwählen.

Bei Problemen gibt es in der FAQ eine Liste der bekannten Probleme unter Linux. Darüber hinaus gibt es mehrere Möglichkeiten, individuelle Hilfe für Neo zu erhalten.

## [Mac OS X](macOS.md)

Wer einen *schönen* Mac hat, möchte ihn auch *schön* und einfach bedienen. Dafür eignet sich Neo vorzüglich. Siehe [macOS](macOS.md).


## [FreeBSD, OpenBSD, NetBSD](BSD.md)

Eines der freiesten Betriebssysteme und an Universitäten nach wie vor verbreitet: FreeBSD. Und das sicherste System will auch sicher bedient werden:  OpenBSD. Das portable NetBSD unterstützt Neo natürlich auch. Siehe [BSD-Systeme](BSD.md).


## [Android](Android.md)

Immer weniger Menschen (relativ gesehen) verwenden „echte“, große Computer (Desktop-Systeme oder Laptops). Glücklicherweise kann man auch direkt auf dem Telefon oder Tablet oder mit einer externen Tastatur an diesen Geräten mit Neo tippen, siehe [Neo unter Android einrichten](Android.md).

## iPhone

!!! important "Wichtig"
    Für das iPhone sind keine Third-Party-Apps bekannt, die es ermöglichen, ein eigenes Layout zu definieren. Wenn jemand eine solche App kennt oder gar Erfahrungen damit gesammelt hat, würden wir uns über eine kurze Benachrichtigung oder Ergänzung freuen.


## Sonstiges

### [Virtuelle Maschinen](/Unsortiert/VM)

Wird ein Betriebssystem in einer virtuellen Maschine installiert, konkurrieren die Tastaturbelegungen von Wirt und Gast miteinander. In den meisten Fällen ist die des Gastes entscheidend, weitere Infos und Problemlösungen gibt es unter [Virtuelle Maschinen](/Unsortiert/VM).
