# Die Neo-Familie

Neo ist nicht nur eine Tastaturbelegung, sondern vielmehr eine ganze Familie von Tastaturbelegungen, den sogenannten Neo-basierten Layouts.
Du hast eventuell schon die Varianten [NeoQwertz](neoqwertz.md) oder [Bone](bone.md) auf der Startseite gesehen, die auf dieser Webseite ebenfalls beheimatet sind.
Diese beiden Tastaturbelegungen teilen die dritte und vierte Ebene mit dem normalem Neo-Layout, lediglich die Buchstaben wurden anders angeordnet, um eine geringere Einstiegshürde zu bieten oder um noch ergonomischer zu sein.

Dies sind jedoch nicht die einzigen Mitglieder der Neo-Familie.
Es gibt eine ganze Fülle an — meist mit Hilfe von Computern optimierten — Layouts, die die Ebenen von Neo mit ergonomischen Buchstabenpositionen kombinieren.
Diese Belegungen tippen sich noch ein bisschen besser als das klassische Neo-Layout.
Jedoch ist der Unterschied zwischen den Varianten so gering, dass der Konsens in der Community ist, dass sich ein Umstieg zwischen diesen Ergonomischen Belegungen meist nicht lohnt.
Der Autor dieses Artikels würde Neulingen allerdings nicht mehr raten, mit dem klassischen Neo-Layout anzufangen.

Neo und Bone haben die Tasten `X`, `C` und `V` auf der linken Seite, was die einhändige Benutzung der häufig nicht änderbaren Abkürzungen für Ausschneiden, Kopieren und Einfügen erheblich vereinfacht.
Bei einigen Varianten ist dies nicht der Fall, was bei der Wahl mit abgewägt werden sollte. Jedoch sei auch auf die [layoutunabhängigen Tastenkombinationen](../Unsortiert/Layoutunabhaengigkeit.md#layoutunabhangige-tastenkombinationen) verwiesen.
Eine schöne Übersicht mit den Bewertungen der Tastaturbelegungen durch Optimierungsprogramme befindet sich in [Max Schillingers Blog](https://maximilian-schillinger.de/keyboard-layouts-neo-adnw-koy.html).

Es sei noch angemerkt, dass für das klassische Neo-Layout erheblich mehr Lernmaterial wie Grafiken, Aufkleber und Tipptrainerlektionen existiert als für andere Neo-basierte Belegungen.

## Mitglieder der Neo-Familie

### Auf dieser Webseite beheimatet
  * [Neo](neo.md) — auch Neo 2 oder klassisches Neo genannt, ist die Hauptvariante von Neo.  
    Informationen zu früheren Versionen finden sich in [Geschichte](/Historisch/Geschichte).

    ![Image](de neo ebene 1.embed.svg)

  * [NeoQwertz](neoqwertz.md) — Die Buchstaben sind wie beim normalen Qwertz-Layout angeordnet.    
    Zum Reinschnuppern und anfixen geeignet.

    ![Image](de neo_qwertz ebene 1.embed.svg)

  * [Bone](bone.md) — Die wahrscheinlich beste hier zu findende Tastaturbelegung.

    ![Image](de bone ebene 1.embed.svg)


### Schon ausgezogen
  * [AdNW (Aus der Neo-Welt)](http://www.adnw.de/) — Eine für Deutsch und für Englisch entworfene Belegung der zentralen Tasten einer Tastatur. Das AdNW-Projekt unterhält eine [eigene Website](http://www.adnw.de/), die auch viele weitere Varianten enthält.

    ![Image](de adnw ebene 1.embed.svg)

  * [BuT](http://www.adnw.de/index.php?n=Main.OptimierungF%c3%bcrDieGeradeTastaturMitDaumen-Shift) — Mit dem AdNW-Optimierer entwickelte Belegung für Matrixtastaturen.

    ![Image](BuT ebene 1.svg)

  * KOY — stammt von AdNW ab. Mehr Informationen finden sich auf der [AdNW-Webseite](http://www.adnw.de/).

    ![Image](de koy ebene 1.embed.svg)

  * [VOU](https://maximilian-schillinger.de/vou-layout.html) — ein Abkömmling von KOY. Der Entwickler hat eine detailreiche Analyse verschiedener Kriterien vorgenommen und die Ergebnisse im Vergleich mit anderen Layouts graphisch erläutert.

    Außerdem enthält die [Homepage](https://www.maximilian-schillinger.de/keyboard-layouts-neo-adnw-koy.html) einen Erfahrungsbericht sowie Gegenüberstellungen einzelner Layouts (Neo, Bone, KOY und eben VOU).

    ![Image](de vou ebene 1.embed.svg)

Diese Liste ist natürlich keineswegs vollständig.

Soweit wir wissen, hat es das Neo-Layout aber noch nicht aus dem deutschen Sprachraum hinaus geschafft.
All diese Belegungen sind (auch) für Deutsch optimiert.
In [Andere Layouts](andere.md) befindet sich eine Liste von diversen ergonomischen Layouts für verschiedensten Sprachen, von denen jedoch keines ein mit Neo vergleichbares Ebenensystem hat.

<!--- ## VM-Belegung
Dieser Modus nimmt Anpassungen bei der Buchstabenbelegung vor. Er heißt „VM“, da neben dem M auch das V auf seinem angestammten Qwertz-Platz verbleibt.

Alle Vokale wurden hier links außen angeordnet, um den linken Zeigefinger vollständig vokalfrei zu haben. Das verringert die Kollisionen von E und O mit den Konsonanten C, W, P und Z deutlich. Gleichzeitig werden die Konsonanten X, V und L von den Vokalen U, I und A getrennt. Fehlt nur noch das Y, das derzeit ganz rechts liegt, und die Vokale liegen auf einem Haufen.

Die sich ergebenden Fingerzuteilungen wurden «nach Gefühl« (also ohne statistische Analysen) optimiert: Alle I/Ü/Y-Laute ganz links, O über U über Ö, A wird von E nach oben geschoben, C und L in der Grundlinie ersetzen E und O. V zurück an seinen Qwertz-Platz, dafür P auf den frei gewordenen Platz von C.

Insgesamt ergibt sich damit die folgende Belegung der Buchstabentasten:
```
Y O A P W K H G F Q ẞ
I U E C L S N R T D X
Ü Ö Ä V Z B M , . J
```

Die Änderungen gegenüber Neo in-a-Nutshell:
 * U und I haben Plätze getauscht.
 * X und Y haben Plätze getauscht.
 * A→L→O→V→P→C→E→A tauschen zyklisch ihre Plätze.

Zusätzlich hat man auch die griechischen Buchstaben mit ihren lateinischen „wandern“ lassen.

### Treiber

Bei Interesse lässt sich das Layout in [NeoVars](/Benutzerhandbuch/NeoVars#konfiguration-und-spezielle-modi) mit folgender Konfiguration einstellen:
```
[Global]
customLayout="-yoapwkhgfqßiueclsnrtdxüöävzbm,.j"
```
Für den Einsatz auf Linux oder Mac bitte im [Neo-Chat](/Kontakt/community#neo-chat) fragen.--->
